

from djitellopy import Tello  # Импорт класса Tello из библиотеки djitellopy
import cv2
import cv2.aruco as aruco
import math
import keyboard
import time
keyboard.add_hotkey('ctrl', lambda: tello.land())


if __name__ == '__main__':  # Основная функция программы
    tello = Tello()  # Создание экземпляра класса Tello
    tello.connect()  # Подключение к дрону
    print(tello.get_battery())
    tello.takeoff()  # Взлет дрона
    tello.set_speed(100)
    time.sleep(2)
    tello.move_up(30) # Подъем дрона на 30 с м

    tello.streamon()  # Включение видеопотока
    # Настройка маркеров и параметров детектора ArUco
    dic = aruco.Dictionary_get(aruco.DICT_4X4_50)
    par = aruco.DetectorParameters_create()
    a = 41  # ID маркера для остановки цикла
    MarkersA = [2, 3, 4, 21, 41]
    while True:
        b = False
        cv2.waitKey(200)
        image = tello.get_frame_read().frame  # Захват изображения
        height, width = image.shape[:2]
        print(height, width)
        image = cv2.flip(image, 0) # Поворот изображения
        gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
        image = cv2.threshold(gray, 90, 255, cv2.THRESH_BINARY_INV + cv2.THRESH_OTSU)[1]
        image = 255 - image

        cv2.imshow("meow", image) # Вывод изображения на экрвн
        # Детекция маркеров ArUco на изображении
        markers, ids, fake, = cv2.aruco.detectMarkers(image, dic, parameters=par)
        if ids is None:
            ids = [-2]
        if len(markers) > 0:
            ids = ids.flatten()
            IDS = int(ids)
            if IDS in MarkersA and IDS == 2:
                MarkersA.remove(IDS)
                print(MarkersA)
                for (sides, i) in zip(markers, ids):
                    markers = sides.reshape((4, 2))
                    (topLeft, topRight, bottomRight, bottomLeft) = markers
                    cX = int((topLeft[0] + bottomRight[0]) / 2)
                    cY = int((topLeft[1] + bottomRight[1]) / 2)
                    cX = 480 - cX
                    cY = 360 - cY
                    print(cX)
                    print(cY)
                    if cX > 50:
                        x = int(cX * 0.05 + 20)
                        tello.move_left(x)
                        print(x)
                    if cX < -50:
                        x = int(cX * -0.05 + 20)
                        tello.move_right(x)
                        print(x)
                    if cY > 150:
                        y = int(cY * 0.05 + 20)
                        tello.move_forward(y)
                        print(y)
                    if cY < -150:
                        y = int(cY * -0.05 + 20)
                        tello.move_back(y)
                        print(y)

                    dif = math.atan((topLeft[1] - topRight[1]) / (topLeft[0] - topRight[0])) / math.acos(-1) * 180
                    if topLeft[1] > bottomLeft[1]:
                        if -dif-180 > 180:
                            tello.rotate_clockwise(int(360-(-dif - 180)))
                        else:
                            tello.rotate_counter_clockwise(int(-dif - 180))

                    else:
                        tello.rotate_clockwise(int(dif))
                    i = 1




            if MarkersA[0] == 3:
                if IDS == 3:
                    MarkersA.remove(IDS)
                    for (sides, i) in zip(markers, ids):
                        markers = sides.reshape((4, 2))
                        (topLeft, topRight, bottomRight, bottomLeft) = markers
                        cX = int((topLeft[0] + bottomRight[0]) / 2)
                        cY = int((topLeft[1] + bottomRight[1]) / 2)
                        cX = 480 - cX
                        cY = 360 - cY
                        print(cX)
                        print(cY)
                        if cX > 50:
                            x = int(cX * 0.05 + 20)
                            tello.move_left(x)
                            print(x)
                        if cX < -50:
                            x = int(cX * -0.05 + 20)
                            tello.move_right(x)
                            print(x)
                        if cY > 150:
                            y = int(cY * 0.05 + 20)
                            tello.move_forward(y)
                            print(y)
                        if cY < -150:
                            y = int(cY * -0.05 + 20)
                            tello.move_back(y)
                            print(y)

                        dif = math.atan((topLeft[1] - topRight[1]) / (topLeft[0] - topRight[0])) / math.acos(-1) * 180
                        if topLeft[1] > bottomLeft[1]:
                            if -dif - 180 > 180:
                                tello.rotate_clockwise(int(360 - (-dif - 180)))
                            else:
                                tello.rotate_counter_clockwise(int(-dif - 180))
                        else:
                            tello.rotate_clockwise(int(dif))
            if MarkersA[0] == 4:
                if IDS == 4:
                    MarkersA.remove(IDS)
                    for (sides, i) in zip(markers, ids):
                        markers = sides.reshape((4, 2))
                        (topLeft, topRight, bottomRight, bottomLeft) = markers
                        cX = int((topLeft[0] + bottomRight[0]) / 2)
                        cY = int((topLeft[1] + bottomRight[1]) / 2)
                        cX = 480 - cX
                        cY = 360 - cY
                        print(cX)
                        print(cY)
                        if cX > 50:
                            x = int(cX * 0.05 + 20)
                            tello.move_left(x)
                            print(x)
                        if cX < -50:
                            x = int(cX * -0.05 + 20)
                            tello.move_right(x)
                            print(x)
                        if cY > 150:
                            y = int(cY * 0.05 + 20)
                            tello.move_forward(y)
                            print(y)
                        if cY < -150:
                            y = int(cY * -0.05 + 20)
                            tello.move_back(y)
                            print(y)

                        dif = math.atan((topLeft[1] - topRight[1]) / (topLeft[0] - topRight[0])) / math.acos(-1) * 180
                        print('dif', dif)
                        if topLeft[1] > bottomLeft[1]:
                            if -dif - 180 > 180:
                                tello.rotate_clockwise(int(360 - (-dif - 180)))
                            else:
                                tello.rotate_counter_clockwise(int(-dif - 180))
                        else:
                            tello.rotate_clockwise(int(dif))
                        i = 1

                        tello.move_forward(30)

                        while i < 12:
                            cv2.waitKey(50)
                            image = tello.get_frame_read().frame
                            image = cv2.flip(image, 0)
                            cv2.imshow('hj', image)
                            markers, ids, fake, = cv2.aruco.detectMarkers(image, dic, parameters=par)
                            if ids is None:
                                ids = [-2]
                            if len(markers) > 0:
                                ids = ids.flatten()
                                IDS = int(ids)
                                if IDS == 21:
                                    break
                            image = image[0:350, 270:630]
                            gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
                            image = gray
                            # gray = gray[0:360, 300:660]
                            thresh = cv2.threshold(gray, 90, 255, cv2.THRESH_BINARY_INV + cv2.THRESH_OTSU)[1]
                            # Find contours and extract the bounding rectangle coordintes
                            # then find moments to obtain the centroid
                            cnts = cv2.findContours(thresh, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_NONE)
                            cnts = cnts[0] if len(cnts) == 2 else cnts[1]
                            for c in cnts:
                                # Obtain bounding box coordinates and draw rectangle
                                x, y, w, h = cv2.boundingRect(c)
                                cv2.rectangle(thresh, (x, y), (x + w, y + h), (36, 255, 12), 2)

                                # Find center coordinate and draw center point
                                M = cv2.moments(c)
                                cv2.imshow('d', thresh)
                                dArea = M['m00']
                                if dArea > 100:
                                    if M['m00'] == 0:
                                        tello.move_forward(20)
                                        print('forward')
                                    else:
                                        cy = int(M['m01'] / M['m00'])
                                        cx = int(M['m10'] / M['m00'])
                                        print('Center: ({})'.format(cx))

                                        dif = int(math.atan((180 - cx) / (360 - cy)) / math.acos(-1) * 180)
                                        if dif < 0:
                                            dif = -dif
                                            if 180 - cx < 0:
                                                print(dif)
                                                tello.rotate_clockwise(dif)
                                                tello.move_forward(20)
                                            else:
                                                print(-dif)
                                                tello.rotate_clockwise(-dif)
                                                tello.move_forward(20)
                                        else:
                                            if 180 - cx < 0:
                                                print(dif)
                                                tello.rotate_clockwise(dif)
                                                tello.move_forward(20)
                                            else:
                                                print(-dif)
                                                tello.rotate_clockwise(-dif)
                                                tello.move_forward(20)
            if MarkersA[0] == 21:
                if IDS == 21:
                    MarkersA.remove(IDS)
                    for (sides, i) in zip(markers, ids):
                        markers = sides.reshape((4, 2))
                        (topLeft, topRight, bottomRight, bottomLeft) = markers
                        cX = int((topLeft[0] + bottomRight[0]) / 2)
                        cY = int((topLeft[1] + bottomRight[1]) / 2)
                        cX = 480 - cX
                        cY = 360 - cY
                        print(cX)
                        print(cY)
                        if cX > 50:
                            x = int(cX * 0.05 + 20)
                            tello.move_left(x)
                            print(x)
                        if cX < -50:
                            x = int(cX * -0.05 + 20)
                            tello.move_right(x)
                            print(x)
                        if cY > 150:
                            y = int(cY * 0.05 + 20)
                            tello.move_forward(y)
                            print(y)
                        if cY < -150:
                            y = int(cY * -0.05 + 20)
                            tello.move_back(y)
                            print(y)

                        dif = math.atan((topLeft[1] - topRight[1]) / (topLeft[0] - topRight[0])) / math.acos(-1) * 180
                        if topLeft[1] > bottomLeft[1]:
                            if -dif - 180 > 180:
                                tello.rotate_clockwise(int(360 - (-dif - 180)))
                            else:
                                tello.rotate_counter_clockwise(int(-dif - 180))
                        else:
                            tello.rotate_clockwise(int(dif))
            if MarkersA[0] == 41:
                if IDS == 41:
                    MarkersA.remove(IDS)
                    for (sides, i) in zip(markers, ids):
                        markers = sides.reshape((4, 2))
                        (topLeft, topRight, bottomRight, bottomLeft) = markers
                        cX = int((topLeft[0] + bottomRight[0]) / 2)
                        cY = int((topLeft[1] + bottomRight[1]) / 2)
                        cX = 480 - cX
                        cY = 360 - cY
                        print(cX)
                        print(cY)
                        if cX > 50:
                            x = int(cX * 0.05 + 20)
                            tello.move_left(x)
                            print(x)
                        if cX < -50:
                            x = int(cX * -0.05 + 20)
                            tello.move_right(x)
                            print(x)
                        if cY > 150:
                            y = int(cY * 0.05 + 20)
                            tello.move_forward(y)
                            print(y)
                        if cY < -150:
                            y = int(cY * -0.05 + 20)
                            tello.move_back(y)
                            print(y)

                        dif = math.atan((topLeft[1] - topRight[1]) / (topLeft[0] - topRight[0])) / math.acos(-1) * 180
                        if topLeft[1] > bottomLeft[1]:
                            if -dif - 180 > 180:
                                tello.rotate_clockwise(int(360 - (-dif - 180)))
                            else:
                                tello.rotate_counter_clockwise(int(-dif - 180))
                        else:
                            tello.rotate_clockwise(int(dif))
                        if i == a or a < 0:
                            b = True
                            tello.move_forward(55)


        # Прерывание цикла, если маркер найден
        if b:
            break

        cv2.waitKey(1)  # Ожидание 1/1000 секунды для правильной работы видео
        tello.move_forward(30)# Движение вперёд на 20 см для поиска маркера
    tello.streamoff()  # Остановка видеопотока
    tello.land()  # Посадка дрона